<h1 align="center">
  <img src=".github/little-spy-itch-cover.png" alt="Little Spy">
  <br />
  Little Spy
</h1>
<div align="center">
<a href="https://wimpress.itch.io/little-spy" target="_blank"><img width="128" src="https://jessemillar.github.io/available-on-itchio-badge/badge-bw.png" /></a>
<a href="https://snapcraft.io/little-spy"><img alt="Get it from the Snap Store" src="https://snapcraft.io/static/images/badges/en/snap-store-black.svg" /></a>
</div>

## Little Spy

### Plot

**Airdrop into an enemy stronghold, find and recover stolen intelligence and technology. *Fight your way out!***

### Objective

Collect as much stolen intelligence and technology as you can and get to the
extraction point before the helicopter leaves without you. Earn a higher agent
ranking by collecting more items and complete the mission as fast as possible
to earn a higher bonus.

<div align="center">
<img src="graphics/medal-gold.png" width="16" alt="Gold">&nbsp;<img src="graphics/medal-silver.png" width="16" alt="Silver">&nbsp;<img src="graphics/medal-bronze.png" width="16" alt="Bronze">&nbsp;
</div>

### Game Mechanics

<img src="graphics/spy_run_1.png" width="16" alt="Spy Run" /> Little Spy can run and jump. **Holding jump extends the jump height**.

<img src="graphics/spy_run_2.png" width="16" alt="Spy Slide" /> **Little Spy is a climber**. They can grab walls and slide down them, jump climb up
them or wall jump away from them.

<img src="graphics/spy_parachute_0.png" width="16" alt="Parachute" /> Like all the best spies, **Little Spy has a gadget**; a parachute that can stow and
deploy itself.

<img src="graphics/spy_jump_3.png" width="16" alt="Spy Kick" /> **Little Spy has a killer flying kick**, which can be used to dash, attack enemies
or double jump.

<img src="graphics/spy_jump_0.png" width="16" alt="Spy Jump" /> Little Spy can **use all of these skills in combination**.

#### The enemies

Enemies can be stomped or kicked:

  * Guards (no helmet) require 1 hit to kill.
  * Soldiers (helmets) require 2 hits to kill.

Enemies have teleport technology and new recruits will teleport into the game
to replace their fallen comrades.

[![Little Spy - gameplay](https://img.youtube.com/vi/MSAkElrsN38/0.jpg)](https://www.youtube.com/watch?v=MSAkElrsN38)

### Controls

Little Spy should work with most game controllers.

<div align="center">
<img src="graphics/controls/XboxOne_Dpad.png" width="32" alt="D-pad">&nbsp;&nbsp;&nbsp;&nbsp;<img src="graphics/controls/XboxOne_Left_Stick.png"  width="32" alt="Left Stick">
<br />
Move
</div>

<div align="center">
<img src="graphics/controls/XboxOne_A.png" width="32" alt="A">&nbsp;&nbsp;&nbsp;
<img src="graphics/controls/XboxOne_B.png" width="32" alt="B">&nbsp;&nbsp;&nbsp;
<img src="graphics/controls/XboxOne_Y.png" width="32" alt="Y">
<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Jump&nbsp;&nbsp;&nbsp;&nbsp;Kick&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Parachute
</div>

#### WASD & Cursors

<div align="center">
<img src="graphics/controls/A_Key_Dark.png" width="32" alt="A">&nbsp;&nbsp;&nbsp;&nbsp;<img src="graphics/controls/D_Key_Dark.png" width="32" alt="D"><br />
<img src="graphics/controls/Arrow_Left_Key_Dark.png" width="32" alt="Left">&nbsp;&nbsp;&nbsp;&nbsp;<img src="graphics/controls/Arrow_Right_Key_Dark.png" width="32" alt="Right">
<br />
Move
</div>

<div align="center">
<img src="graphics/controls/W_Key_Dark.png"  width="32" alt="W">&nbsp;&nbsp;&nbsp;&nbsp;<img src="graphics/controls/Arrow_Up_Key_Dark.png" width="32" alt="Up">
<br />
Jump
</div>

<div align="center">
<img src="graphics/controls/S_Key_Dark.png" width="32" alt="S">&nbsp;&nbsp;&nbsp;&nbsp;<img src="graphics/controls/Arrow_Down_Key_Dark.png" width="32" alt="Down">
<br />
Parachute
</div>

<div align="center">
<img src="graphics/controls/Space_Key_Dark.png"  width="32" alt="Space">
<br />
Kick
</div>

## My First Game Jam: Summer 2021

Little Spy is my entry in the [My First Game Jam: Summer 2021](https://itch.io/jam/my-first-game-jam-summer-2021).

The theme for the jam was ✨Free✨. My interpretation of the theme is to create
a game using only tools that are free software, free of cost, or game assets
that are free or in the public domain.

In keeping with the **Free** theme, I released the game project and code under
an MIT license.

### Dev Log

I've been wanting to learn Godot for a while now, so decided to use this jam as
motivation. I haven't written a game since the 1980s, but I have a background
in software development. My DevLog from the jam is below:

  * [Little Spy - DevLog](https://itch.io/jam/my-first-game-jam-summer-2021/topic/1497343/little-spy-devlog)

## Tools

I used these excellent tools to make the game.

  * [Godot Engine](https://godotengine.org/)
  * [GIMP](https://www.gimp.org/)
  * [Ocenaudio](https://www.ocenaudio.com/)
  * [Ubuntu MATE](https://ubuntu-mate.org)

## Credits

  * Code & Game Design: [Martin Wimpress](https://twitter.com/m_wimpress)

A big *"Thank you!"* to everyone below who makes their art 🖌
music 🎶 or sounds 🔊 freely available for others to build on. Little Spy would
have been shapes and silence had it not been for these fine people:

  * Sprites
    * Spy: [DezrasDragons](https://opengameart.org/users/dezrasdragons) & [GrafxKid](https://opengameart.org/users/grafxkid)
    * Guard & Soldier [Umz](https://opengameart.org/users/umz) & [GrafxKid](https://opengameart.org/users/grafxkid)
    * Military items: [AngryMeteor.com](https://opengameart.org/content/140-military-icons-set-fixed)
    * Helicopter: [Hobo](https://opengameart.org/users/hobo)
  * Backgrounds: [Segel](https://opengameart.org/users/segel)
  * Tiles: [RottingPixels](https://opengameart.org/users/rottingpixels)
  * Controller and Keyboard: [xelu](https://opengameart.org/users/xelu)
  * Sound: [rubberduck](https://opengameart.org/users/rubberduck)
  * Music:
      * [artisticdude](https://opengameart.org/users/artisticdude)
        * [Covert Operations](https://opengameart.org/content/covert-operations) - Even numbered levels
        * [Determination](https://opengameart.org/content/determination) - Off numbered levels
      * [Kistol](https://opengameart.org/users/kistol)
        * [Game Over](https://opengameart.org/content/game-over) - Game Over
      * [Jonathan Shaw](www.jshaw.co.uk)
        * [The Tread of War](https://opengameart.org/content/the-tread-of-war-rpg-orchestral-essentials-military-music) - Mission Accomplished
  * Fonts:
    * [Great Lakes](https://www.dafont.com/great-lakes-nf.font)
    * [i pixel u](https://www.dafont.com/i-pixel-u.font)

I published a collection on [OpenGameArt.org](https://opengameart.org) that
includes everything I used from OGA.

  * <https://opengameart.org/content/little-spy>

## Screenshots

<div align="center">
  <img src=".github/screenshots/level00-little-spy.png" alt="Little Spy - Main Screen" width="480">
  <br />
  <b>Main Screen</b>
</div>
<br />

<div align="center">
  <img src=".github/screenshots/level01-little-spy.png" alt="Little Spy - Level 01" width="480">
  <br />
  <b>Level 01</b> - "<i>Just Jumping</i>"
</div>
<br />

<div align="center">
  <img src=".github/screenshots/level02-little-spy.png" alt="Little Spy - Level 02" width="480">
  <br />
  <b>Level 02</b> - "<i>One Item Required</i>"
</div>
<br />

<div align="center">
  <img src=".github/screenshots/level03-little-spy.png" alt="Little Spy - Level 03" width="480">
  <br />
  <b>Level 03</b> - "<i>Do the Stomp!</i>"
</div>
<br />

<div align="center">
  <img src=".github/screenshots/level04-little-spy.png" alt="Little Spy - Level 04" width="480">
  <br />
  <b>Level 04</b> - "<i>Floaty McFloat Face</i>"
</div>
<br />
